(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(if vlisp-optimiser (vlisp-optimiser nil)) ;; disable VLisp-Optimiser, if present
(defun eq-nil ( count / val )
  (setq val 123)
  (repeat (* count count)
    (eq val nil)
    (eq nil val)
  )
)

(if vlisp-optimiser (vlisp-optimiser t)) ;; enable VLisp-Optimiser, if present
(defun eq-nil-opt ( count / val )
  (setq val 123)
  (repeat (* count count)
    (eq val nil)
    (eq nil val)
  )
)

(defun t_opt_eq_nil ( count fptr / time1 time2 time3 time4 )
    
  ;;--- now run test : normal
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (eq-nil count)

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))

  ;;--- now run test : optimised
  (setq time3 (getvar "MILLISECS"))
  (if (not time3) (setq time3 (getvar "TDUSRTIMER")))
  (if (not time3) (setq time3 0.0))

  (eq-nil-opt count)

  (setq time4 (getvar "MILLISECS"))
  (if (not time4) (setq time4 (getvar "TDUSRTIMER")))
  (if (not time4) (setq time4 0.0))

  ;;--- test results
  (setq bench$secsNorm (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (setq bench$secsFast (if hasMilliSecs (* 0.001 (- time4 time3)) (* 86400.0 (- time4 time3))))
  (setq bench$seconds (+ bench$secsNorm bench$secsFast))

  (princ (strcat "* (eq x nil) : " (rtos bench$secsNorm 2 3) "  (eq x nil) optimised : " (rtos bench$secsFast 2 3) "\n"))
  (if fptr
    (princ (strcat "* (eq x nil) : " (rtos bench$secsNorm 2 3) "  (eq x nil) optimised : " (rtos bench$secsFast 2 3) "\n") fptr)
  )

  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_opt_eq_nil (* 750 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
