(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vlconsp ( count fptr / time1 time2 lst1 lst2 )

  ;;-----------------------------
  (setq lst1 (cons 0 "LINE"))
  (setq lst2 '(1 2 3))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (vl-consp nil)
    (vl-consp t)
    (vl-consp 3)
    (vl-consp "")
    (vl-consp lst1)
    (vl-consp lst2)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VL-CONSP : " (rtos bench$seconds 2 3) "\n"))
  (if fptr                                     
    (princ (strcat "* VL-CONSP : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vlconsp (* 1000 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
