(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vldocref ( count fptr / time1 time2 )

  ;;-----------------------------
  (vl-doc-set 'var1 t)
  (vl-doc-set 'var2 123)
  (vl-doc-set 'var3 123.456)
  (vl-doc-set 'var4 "abc")
  (vl-doc-set 'var5 nil)
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (vl-doc-ref 'var1)
    (vl-doc-ref 'var2)
    (vl-doc-ref 'var3)
    (vl-doc-ref 'var4)
    (vl-doc-ref 'var5)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VL-DOC-REF : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* VL-DOC-REF : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vldocref (* 200 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
