(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vlregistry ( count fptr / time1 time2 )
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (vl-registry-read   "HKEY_CURRENT_USER\\Test-Dummy" "")
    (vl-registry-write  "HKEY_CURRENT_USER\\Test-Dummy" "" "test val")
    (vl-registry-read   "HKEY_CURRENT_USER\\Test-Dummy" "")
    (vl-registry-delete "HKEY_CURRENT_USER\\Test-Dummy" "")

    (vl-registry-read   "HKEY_CURRENT_USER\\Test-Dummy" "Val-1")
    (vl-registry-write  "HKEY_CURRENT_USER\\Test-Dummy" "Val-1" 1234)
    (vl-registry-read   "HKEY_CURRENT_USER\\Test-Dummy" "Val-1")
    (vl-registry-delete "HKEY_CURRENT_USER\\Test-Dummy" "Val-1")

    (vl-registry-delete "HKEY_CURRENT_USER\\Test-Dummy")
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VL-REGISTRY-XXX : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* VL-REGISTRY-XXX : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vlregistry (* 25 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
