(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(if vlisp-optimiser (vlisp-optimiser nil)) ;; disable VLisp-Optimiser, if present

(defun t_vla_fastcom_getcolor ( count fptr / ename vlaen time1 time2 time3 time4 )

  ;;--- build data list
  (setq elist '((0 . "LINE") (8 . "0") (62 . 4) (10 0 0 0) (11 10 10 10) (370 . 100)))
  (entmake elist)
  (setq ename (entlast))
  (setq vlaen (vlax-ename->vla-object ename))

  ;;--- now run test : VLA (default)
  (if lisp$enablefastcom (lisp$enablefastcom nil)) ;; disable FAST COM, if present
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (vla-get-Color vlaen)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))

  ;;--- now run test : VLA (fast COM)
  (if lisp$enablefastcom (lisp$enablefastcom t)) ;; enable FAST COM, if present
  (setq time3 (getvar "MILLISECS"))
  (if (not time3) (setq time3 (getvar "TDUSRTIMER")))
  (if (not time3) (setq time3 0.0))

  (repeat (* count count)
    (vla-get-Color vlaen)
  )

  (setq time4 (getvar "MILLISECS"))
  (if (not time4) (setq time4 (getvar "TDUSRTIMER")))
  (if (not time4) (setq time4 0.0))

  ;;--- cleanup
  (entdel ename)
  ;;--- test results
  (setq bench$secsNorm (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (setq bench$secsFast (if hasMilliSecs (* 0.001 (- time4 time3)) (* 86400.0 (- time4 time3))))
  (setq bench$seconds (+ bench$secsNorm bench$secsFast))

  (princ (strcat "* VLA-GET-COLOR (default) : " (rtos bench$secsNorm 2 3) "  (fast COM) : " (rtos bench$secsFast 2 3) "\n"))
  (if fptr
    (princ (strcat "* VLA-GET-COLOR (default) : " (rtos bench$secsNorm 2 3) "  (fast COM) : " (rtos bench$secsFast 2 3) "\n") fptr)
  )

  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vla_fastcom_getcolor (* 300 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
