(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vla_getactiveucs ( count fptr / time1 time2 app dwg )
  ;;-----------------------------
  (setq app (vlax-get-acad-object))
  (setq dwg (vla-get-activedocument app))
  (command "_ucs" "_z" 45)
  (command "_ucs" "_save" "xxx")
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (vla-get-activeucs dwg)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (command "_ucs" "_world")
  (command "_ucs" "_delete" "xxx")
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VLA-GET-ACTIVEUCS : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* VLA-GET-ACTIVEUCS : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vla_getactiveucs (* 200 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
