(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vla_putlayer ( count fptr / time1 time2 elist ename vlaen )
  ;;--- build data list
  (setq elist '((0 . "LINE") (8 . "1") (62 . 4) (10 0 0 0) (11 10 10 10) (370 . 100)))
  (entmake elist)
  (setq ename (entlast))
  (setq vlaen (vlax-ename->vla-object ename))

  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (/ (* count count) 2)
    (vla-put-layer vlaen "0")
    (vla-put-layer vlaen "1")
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (entdel ename)
  ;;-----------------------------

  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VLA-PUT-LAYER : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* VLA-PUT-LAYER : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vla_putlayer (* 300 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
