(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(vl-load-com)
(setvar "LOGFILEMODE" 0)

(defun t_safearray-value ( count fptr / time1 time2 dbl str )
  ;;-----------------------------
  (setq dbl (vlax-make-safearray vlax-vbdouble '(0 . 2)))
  (vlax-safearray-fill dbl  '(4.0 5.0 6.0))
  ;;--- undocumented safearray-value only allows 1-dimensional arrays
  (setq str (vlax-make-safearray vlax-vbString '(0 . 5)))
  (vlax-safearray-fill str '("a" "b" "c" "d" "e" "f"))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))
 
  (repeat (* count count)
    (safearray-value dbl)
    (safearray-value str)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "*      SAFEARRAY-VALUE : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "*      SAFEARRAY-VALUE : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_safearray-value (* 200 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
