(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_variant ( count fptr / time1 time2 4dubs )
  ;;-----------------------------
  (setq 4dubs (vlax-make-safearray vlax-vbDouble '(0 . 3)))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
     (variant)
     (variant nil)
     (variant :vlax-false)
     (variant :vlax-true)
     (variant 5 vlax-vbInteger)
     (variant 5 vlax-vbLong)
     (variant 5)
     (variant 5.0 vlax-vbSingle)
     (variant 5.0 vlax-vbDouble)
     (variant 5.0)
     (variant "ghost 1")
     (variant "ghost 2" vlax-vbString)
     (variant 4dubs)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "*           VARIANT : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "*           VARIANT : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_variant (* 300 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
