(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vlax-ldata-get ( count fptr / time1 time2 )

  ;;-----------------------------
  (vlax-ldata-put "Dict1" "Key0" 123)
  (vlax-ldata-put "Dict1" "Key1" 123.456)
  (vlax-ldata-put "Dict1" "Key2" (list 123 "abc"))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (vlax-ldata-get "Dict0" "Key1" "?")
    (vlax-ldata-get "Dict1" "Key1" "?")
    (vlax-ldata-get "Dict2" "Key1" "?")
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VLAX-LDATA-GET : " (rtos bench$seconds 2 3) "\n"))
  (if fptr                                     
    (princ (strcat "* VLAX-LDATA-GET : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vlax-ldata-get (* 125 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
