(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vlax-erased-p ( count fptr / time1 time2 
                                      ename vlaen )

  ;;-----------------------------
  (entmake '((0 . "POINT")(10 0.0 0.0 0.0)))
  (setq ename (entlast))
  (setq vlaen (vlax-ename->vla-object ename))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (vlax-erased-p ename)
    (vlax-erased-p vlaen)
  )

  (entdel ename)

  (repeat (* count count)
    (vlax-erased-p ename)
    (vlax-erased-p vlaen)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VLAX-ERASED-P : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* VLAX-ERASED-P : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vlax-erased-p (* 200 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
