(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vlax-get-property ( count fptr / time1 time2 app dwg )
  ;;-----------------------------
  (setq app (vlax-get-acad-object))
  (setq dwg (vla-get-ActiveDocument app))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (vlax-get-property app 'ActiveDocument)
    (vlax-get-property app "ActiveDocument")

    (vlax-get-property dwg 'activedimstyle)
    (vlax-get-property dwg "activedimstyle")

    (vlax-get-property dwg 'activelayer)
    (vlax-get-property dwg "activelayer")

    (vlax-get-property dwg 'activelayout)
    (vlax-get-property dwg "activelayout")

    (vlax-get-property dwg 'activelinetype)
    (vlax-get-property dwg "activelinetype")

    (vlax-get-property dwg 'activespace)
    (vlax-get-property dwg "activespace")

    (vlax-get-property dwg 'activetextstyle)
    (vlax-get-property dwg "activetextstyle")

    (vlax-get-property dwg 'Modelspace)
    (vlax-get-property dwg "Modelspace")
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VLAX-GET-PROPERTY : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* VLAX-GET-PROPERTY : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vlax-get-property (* 50 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
