(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vlax-import-type-library ( count fptr / time1 time2 
                                                 tlb res )

  ;;-----------------------------
  (setq tlb (findfile "Benches\\Vlax\\Excel9.olb"))
  (if (not tlb)
    (progn
      (alert "no type library 'Excel9.olb' found")
      (exit)
    )
  )
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (setq res (vlax-import-type-library
                 :tlb-filename tlb
                 :methods-prefix "msxl-"
                 :properties-prefix "msxl-"
                 :constants-prefix "msxl-"
              )
    )
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VLAX-IMPORT-TYPE-LIBRARY : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* VLAX-IMPORT-TYPE-LIBRARY : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vlax-import-type-library (* 3 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
