(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vlax-put ( count fptr / time1 time2 acadObject app dwg actlayer actltype acttxtstyle actdimstyle )
  ;;-----------------------------
  (setq app (vlax-get-acad-object))
  (setq dwg (vla-get-ActiveDocument app))
  (setq actlayer    (vlax-get-property dwg "activelayer"))
  (setq actltype    (vlax-get-property dwg "activelinetype"))
  (setq acttxtstyle (vlax-get-property dwg "activetextstyle"))
  (setq actdimstyle (vlax-get-property dwg "activedimstyle"))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
      (vlax-put dwg 'activelayer      actlayer)
      (vlax-put dwg "activelayer"     actlayer)

      (vlax-put dwg 'activelinetype   actltype)
      (vlax-put dwg "activelinetype"  actltype)

      (vlax-put dwg 'activetextstyle  acttxtstyle)
      (vlax-put dwg "activetextstyle" acttxtstyle)

      (vlax-put dwg 'activedimstyle   actdimstyle)
      (vlax-put dwg "activedimstyle"  actdimstyle)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VLAX-PUT : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* VLAX-PUT : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vlax-put (* 50 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
