(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vlax-safearray-fill ( count fptr / time1 time2 sa str mat )
  ;;-----------------------------
  (setq sa  (vlax-make-safearray vlax-vbdouble '(0 . 2)))
  (setq str (vlax-make-safearray vlax-vbString '(1 . 3)))
  (setq mat (vlax-make-safearray vlax-vbString '(0 . 1) '(1 . 3)))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))
 
  (repeat (* count count)
       (vlax-safearray-fill sa  '(1 2 3))
       (vlax-safearray-fill sa  '(4.0 5.0 6.0))
       (vlax-safearray-fill str '("XXX" "YYY" "ZZZ"))
       (vlax-safearray-fill mat '(("a" "b" "c") ("d" "e" "f")))
       (vlax-safearray-fill mat '(("U" "V" "W") ("X" "Y" "Z")))
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VLAX-SAFEARRAY-FILL : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* VLAX-SAFEARRAY-FILL : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vlax-safearray-fill (* 100 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
