(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vlax-variant-change-type ( count fptr / time1 time2 varint varstr )
  ;;-----------------------------
  (setq varint (vlax-make-variant 5 vlax-vbLong))
  (setq varstr (vlax-make-variant "5" vlax-vbString))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
      (vlax-variant-change-type varint vlax-vbLong)   ;; NOOP
      (vlax-variant-change-type varstr vlax-vbString) ;; NOOP
      ;----
      (vlax-variant-change-type varint vlax-vbstring)
      (vlax-variant-change-type varstr vlax-vbLong)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VLAX-VARIANT-CHANGE-TYPE : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* VLAX-VARIANT-CHANGE-TYPE : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vlax-variant-change-type (* 500 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
