(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(defun t_vlax-variant-value ( count fptr / time1 time2
                                           varNull varNil varFalse varShort varLong varFlt varDbl varStr varPnt
                            )

  ;;-----------------------------
  (setq varNull  (vlax-make-variant))
  (setq varNil   (vlax-make-variant nil))
  (setq varFalse (vlax-make-variant :vlax-false))
  (setq varShort (vlax-make-variant 5 vlax-vbInteger))
  (setq varLong  (vlax-make-variant 5 vlax-vbLong))
  (setq varFlt   (vlax-make-variant 5.0 vlax-vbSingle))
  (setq varDbl   (vlax-make-variant 5.0 vlax-vbDouble))
  (setq varStr   (vlax-make-variant "ghost"))
  (setq varPnt   (vlax-3d-point 1 2 3))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))
 
  (repeat (* count count)
      (vlax-variant-value varNull)
      (vlax-variant-value varNil)
      (vlax-variant-value varFalse)
      (vlax-variant-value varShort)
      (vlax-variant-value varLong)
      (vlax-variant-value varFlt)
      (vlax-variant-value varDbl)
      (vlax-variant-value varStr)
      (vlax-variant-value varPnt)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* VLAX-VARIANT-VALUE : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* VLAX-VARIANT-VALUE : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vlax-variant-value (* 400 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
