(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(if (and (not vle-entget-m) (findfile "vle-extension.lsp")) (load "vle-extension.lsp"))

(if vlisp-optimizer (vlisp-optimizer nil))

(defun t_vle_entget_m ( count fptr / ename elist vlaen dxfList res lst time1 time2 time3 time4 time5 time6 )

  ;;--- build data list
  (setq elist '((0 . "LINE")(8 . "0")(62 . 1)(10 0 0 0)(11 10 10 10)(39 . 1.0)))
  (setq ename (entmakex elist))
  (setq vlaen (vlax-ename->vla-object ename))
  (setq dxfList '(0 8 62 10 11 39))

  ;;--- now run test : NORMAL
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (setq elist (entget ename) lst nil)
    (if (setq res (assoc 0  elist)) (setq lst (cons res lst)))
    (if (setq res (assoc 8  elist)) (setq lst (cons res lst)))
    (if (setq res (assoc 62 elist)) (setq lst (cons res lst)))
    (if (setq res (assoc 10 elist)) (setq lst (cons res lst)))
    (if (setq res (assoc 11 elist)) (setq lst (cons res lst)))
    (if (setq res (assoc 39 elist)) (setq lst (cons res lst)))
    (reverse lst)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))

  ;;--- now run test : VLA
  (setq time3 (getvar "MILLISECS"))
  (if (not time3) (setq time3 (getvar "TDUSRTIMER")))
  (if (not time3) (setq time3 0.0))

  (repeat (* count count)
    (setq lst nil)
    (if (setq res (vla-get-objectname vlaen)) (setq lst (cons res lst)))
    (if (setq res (vla-get-layer vlaen))      (setq lst (cons res lst)))
    (if (setq res (vla-get-color vlaen))      (setq lst (cons res lst)))
    (if (setq res (vla-get-startpoint vlaen)) (setq lst (cons res lst)))
    (if (setq res (vla-get-endpoint vlaen))   (setq lst (cons res lst)))
    (if (setq res (vla-get-thickness vlaen))  (setq lst (cons res lst)))
  )

  (setq time4 (getvar "MILLISECS"))
  (if (not time4) (setq time4 (getvar "TDUSRTIMER")))
  (if (not time4) (setq time4 0.0))

  ;;--- now run test : FAST
  (setq time5 (getvar "MILLISECS"))
  (if (not time5) (setq time5 (getvar "TDUSRTIMER")))
  (if (not time5) (setq time5 0.0))

  (repeat (* count count)
    (vle-entget-m dxfList ename)
  )

  (setq time6 (getvar "MILLISECS"))
  (if (not time6) (setq time6 (getvar "TDUSRTIMER")))
  (if (not time6) (setq time6 0.0))

  ;;--- test results
  (setq bench$secsNorm (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (setq bench$secsVla  (if hasMilliSecs (* 0.001 (- time4 time3)) (* 86400.0 (- time4 time3))))
  (setq bench$secsFast (if hasMilliSecs (* 0.001 (- time6 time5)) (* 86400.0 (- time6 time5))))
  (setq bench$seconds (+ bench$secsNorm bench$secsVla bench$secsFast))
  ;;-----------------------------
  (entdel ename)
  ;;-----------------------------

  (princ (strcat "* MULTI (ENTGET): " (rtos bench$secsNorm 2 3) "  MULTI VLA-GET-XXX: " (rtos bench$secsVla 2 3) "  VLE-ENTGET-M: " (rtos bench$secsFast 2 3) "\n"))
  (if fptr
    (princ (strcat "* MULTI(ENTGET): " (rtos bench$secsNorm 2 3) " MULTI VLA-GET-XXX: " (rtos bench$secsVla 2 3) "  VLE-ENTGET-M: " (rtos bench$secsFast 2 3) "\n") fptr)
  )

  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vle_entget_m (* 200 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
