(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(if (and (not vle-entmod) (findfile "vle-extension.lsp")) (load "vle-extension.lsp"))

(defun std-entmod ( ename dxf value / olditem lst )
  (if (setq lst (entget ename))
    (if (setq olditem (assoc dxf lst))
      (and (entmod (subst (cons dxf value) olditem lst)))
      (and (entmod (append lst (list (cons dxf value)))))
    )
  )
)

(defun t_vle_entmod_dxf8 ( count fptr / ename elist vlaen time1 time2 time3 time4 time5 time6 )

  ;;--- build data list
  (setq elist '((0 . "LINE") (8 . "1") (62 . 4) (10 0 0 0) (11 10 10 10) (370 . 100)))
  (entmake elist)
  (setq ename (entlast))
  (setq vlaen (vlax-ename->vla-object ename))

  ;;--- now run test : NORMAL
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (/ (* count count) 2)
    (std-entmod ename 8 "0")
    (std-entmod ename 8 "1")
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))

  ;;--- now run test : VLA
  (setq time3 (getvar "MILLISECS"))
  (if (not time3) (setq time3 (getvar "TDUSRTIMER")))
  (if (not time3) (setq time3 0.0))

  (repeat (/ (* count count) 2)
    (vla-put-layer vlaen "0")
    (vla-put-layer vlaen "1")
  )

  (setq time4 (getvar "MILLISECS"))
  (if (not time4) (setq time4 (getvar "TDUSRTIMER")))
  (if (not time4) (setq time4 0.0))

  ;;--- now run test : FAST
  (setq time5 (getvar "MILLISECS"))
  (if (not time5) (setq time5 (getvar "TDUSRTIMER")))
  (if (not time5) (setq time5 0.0))

  (repeat (/ (* count count) 2)
    (vle-entmod 8 ename "0")
    (vle-entmod 8 ename "1")
  )

  (setq time6 (getvar "MILLISECS"))
  (if (not time6) (setq time6 (getvar "TDUSRTIMER")))
  (if (not time6) (setq time6 0.0))

  ;;--- test results
  (setq bench$secsNorm (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (setq bench$secsVla  (if hasMilliSecs (* 0.001 (- time4 time3)) (* 86400.0 (- time4 time3))))
  (setq bench$secsFast (if hasMilliSecs (* 0.001 (- time6 time5)) (* 86400.0 (- time6 time5))))
  (setq bench$seconds (+ bench$secsNorm bench$secsVla bench$secsFast))
  ;;-----------------------------
  (entdel ename)
  ;;-----------------------------

  (princ (strcat "* (ENTMOD 8): " (rtos bench$secsNorm 2 3) "  VLA-PUT-LAYER: " (rtos bench$secsVla 2 3) "  VLE-ENTMOD 8: " (rtos bench$secsFast 2 3) "\n"))
  (if fptr
    (princ (strcat "* (ENTMOD 8): " (rtos bench$secsNorm 2 3) "  VLA-PUT-LAYER: " (rtos bench$secsVla 2 3) "  VLE-ENTMOD 8: " (rtos bench$secsFast 2 3) "\n") fptr)
  )

  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vle_entmod_dxf8 (* 150 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
