(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(if (and (not vle-file->list) (findfile "vle-extension.lsp")) (load "vle-extension.lsp"))

(defun emul-file->list ( filename cchar / linelst fline fptr )
  (if (setq fptr (open (findfile filename) "r"))
    (while (setq fline (read-line fptr))
      (if (or (not cchar) (/= (substr fline 1 1) cchar))
        (setq linelst (cons fline linelst))
      )
    )
  )
  (if fptr (close fptr))
  (reverse linelst)
)  

(defun t_vle_file->list ( count fptr / testfile time1 time2 time3 time4 )

  ;;--- build data list
  (if (not (setq testfile (findfile "Benches\\=TestFile-Small=.lsx")))
    (progn
      (alert "Test Data file : <=TestFile-Small=.lsx> not found - exiting !")
      (exit)
    )
  )

  ;;--- now run test : NORMAL
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (emul-file->list testfile nil)
    (emul-file->list testfile ";")
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))

  ;;--- now run test : VLE
  (setq time3 (getvar "MILLISECS"))
  (if (not time3) (setq time3 (getvar "TDUSRTIMER")))
  (if (not time3) (setq time3 0.0))

  (repeat (* count count)
    (vle-file->list testfile nil)  
    (vle-file->list testfile ";")
  )

  (setq time4 (getvar "MILLISECS"))
  (if (not time4) (setq time4 (getvar "TDUSRTIMER")))
  (if (not time4) (setq time4 0.0))

  ;;--- test results
  (setq bench$secsNorm (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (setq bench$secsFast (if hasMilliSecs (* 0.001 (- time4 time3)) (* 86400.0 (- time4 time3))))
  (setq bench$seconds (+ bench$secsNorm bench$secsFast))

  (princ (strcat "* (Standard) : " (rtos bench$secsNorm 2 3) "  VLE-FILE->LIST : " (rtos bench$secsFast 2 3) "\n"))
  (if fptr
    (princ (strcat "* (Standard) : " (rtos bench$secsNorm 2 3) "  VLE-FILE->LIST : " (rtos bench$secsFast 2 3) "\n") fptr)
  )

  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vle_file->list (* 30 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
