(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(if (and (not vle-roundto) (findfile "vle-extension.lsp")) (load "vle-extension.lsp"))

(defun t_vle_roundto ( count fptr / lst time1 time2 time3 time4 )

  ;;--- now run test : NORMAL
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (atof (rtos 1.23456789 2 0))
    (atof (rtos 1.23456789 2 1))
    (atof (rtos 1.23456789 2 2))
    (atof (rtos 1.23456789 2 3))
    (atof (rtos 1.23456789 2 4))
    (atof (rtos 1.23456789 2 5))
    (atof (rtos 1.23456789 2 6))
    (atof (rtos 1.23456789 2 7))
    (atof (rtos 1.23456789 2 8))
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))

  ;;--- now run test : VLE
  (setq time3 (getvar "MILLISECS"))
  (if (not time3) (setq time3 (getvar "TDUSRTIMER")))
  (if (not time3) (setq time3 0.0))

  (repeat (* count count)
    (vle-roundto 1.23456789 0)
    (vle-roundto 1.23456789 1)
    (vle-roundto 1.23456789 2)
    (vle-roundto 1.23456789 3)
    (vle-roundto 1.23456789 4)
    (vle-roundto 1.23456789 5)
    (vle-roundto 1.23456789 6)
    (vle-roundto 1.23456789 7)
    (vle-roundto 1.23456789 8)
  )

  (setq time4 (getvar "MILLISECS"))
  (if (not time4) (setq time4 (getvar "TDUSRTIMER")))
  (if (not time4) (setq time4 0.0))

  ;;--- test results
  (setq bench$secsNorm (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (setq bench$secsFast (if hasMilliSecs (* 0.001 (- time4 time3)) (* 86400.0 (- time4 time3))))
  (setq bench$seconds (+ bench$secsNorm bench$secsFast))

  (princ (strcat "* (Standard) : " (rtos bench$secsNorm 2 3) "  VLE-ROUNDTO : " (rtos bench$secsFast 2 3) "\n"))
  (if fptr
    (princ (strcat "* (Standard) : " (rtos bench$secsNorm 2 3) "  VLE-ROUNDTO : " (rtos bench$secsFast 2 3) "\n") fptr)
  )

  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vle_roundto (* 200 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
