(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(if (and (not vle-string-split) (findfile "vle-extension.lsp")) (load "vle-extension.lsp"))

(defun emul-vle-string-split ( keys string / retlst idx len start keylst strlst )
  (setq idx 1 start 1 len (strlen string))
  (setq keylst (vl-string->list keys))
  (setq strlst (cons 0 (vl-string->list string)))
  (while (setq strlst (cdr strlst))
    (if (member (car strlst) keylst)
      (setq retlst (cons (substr string start (- idx start)) retlst)
            idx (1+ idx)
            start idx
      )
      (setq idx (1+ idx))
    )
  )
  (if retlst
    (reverse (cons (substr string start (1+ (- len start))) retlst))
    (list string)
  )
)

(defun t_vle_string_split ( count fptr / lst time1 time2 time3 time4 )

  ;;--- build data list
  (setq lst '(0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15))

  ;;--- now run test : NORMAL
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (emul-vle-string-split ";" "xxx")
    (emul-vle-string-split ";" "xxx ; yyy")
    (emul-vle-string-split ";," "xxx ; yyy")
    (emul-vle-string-split ";," ", xxx ; yyy,")
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))

  ;;--- now run test : VLE
  (setq time3 (getvar "MILLISECS"))
  (if (not time3) (setq time3 (getvar "TDUSRTIMER")))
  (if (not time3) (setq time3 0.0))

  (repeat (* count count)
    (vle-string-split ";" "xxx")
    (vle-string-split ";" "xxx ; yyy")
    (vle-string-split ";," "xxx ; yyy")
    (vle-string-split ";," ", xxx ; yyy,")
  )

  (setq time4 (getvar "MILLISECS"))
  (if (not time4) (setq time4 (getvar "TDUSRTIMER")))
  (if (not time4) (setq time4 0.0))

  ;;--- test results
  (setq bench$secsNorm (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (setq bench$secsFast (if hasMilliSecs (* 0.001 (- time4 time3)) (* 86400.0 (- time4 time3))))
  (setq bench$seconds (+ bench$secsNorm bench$secsFast))

  (princ (strcat "* (Standard) : " (rtos bench$secsNorm 2 3) "  VLE-STRING-SPLIT : " (rtos bench$secsFast 2 3) "\n"))
  (if fptr
    (princ (strcat "* (Standard) : " (rtos bench$secsNorm 2 3) "  VLE-STRING-SPLIT : " (rtos bench$secsFast 2 3) "\n") fptr)
  )

  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vle_string_split (* 150 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
