(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)
(vl-load-com)

(if (and (not vle-sublist) (findfile "vle-extension.lsp")) (load "vle-extension.lsp"))

(defun emul-vle-sublist ( lst startidx nritems / retlst )
  (if (<  startidx 0) (setq startidx 0))
  ;;--- position to first required index
  (while (> startidx 0) (setq lst (cdr lst) startidx (1- startidx)))
  ;;--- extract 'nritems' from list 'lst'
  (if (<= nritems 0)
    (setq retlst lst)
    (progn
      (while (and lst (> nritems 0))
        (setq retlst (cons (car lst) retlst) lst (cdr lst) nritems (1- nritems))
      )
      (setq retlst (reverse retlst))
    )
  )
  retlst
)

(defun t_vle_sublist ( count fptr / lst time1 time2 time3 time4 )

  ;;--- build data list
  (setq lst '(0 1 2 3 4 5 6 7 8 9))

  ;;--- now run test : NORMAL
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (emul-vle-sublist lst -1 1)
    (emul-vle-sublist lst -1 5)
    (emul-vle-sublist lst  4 0)
    (emul-vle-sublist lst  5 1)
    (emul-vle-sublist lst  6 5)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))

  ;;--- now run test : VLE
  (setq time3 (getvar "MILLISECS"))
  (if (not time3) (setq time3 (getvar "TDUSRTIMER")))
  (if (not time3) (setq time3 0.0))

  (repeat (* count count)
    (vle-sublist lst -1 1)
    (vle-sublist lst -1 5)
    (vle-sublist lst  4 0)
    (vle-sublist lst  5 1)
    (vle-sublist lst  6 5)
  )

  (setq time4 (getvar "MILLISECS"))
  (if (not time4) (setq time4 (getvar "TDUSRTIMER")))
  (if (not time4) (setq time4 0.0))

  ;;--- test results
  (setq bench$secsNorm (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (setq bench$secsFast (if hasMilliSecs (* 0.001 (- time4 time3)) (* 86400.0 (- time4 time3))))
  (setq bench$seconds (+ bench$secsNorm bench$secsFast))

  (princ (strcat "* (Standard) : " (rtos bench$secsNorm 2 3) "  VLE-SUBLIST : " (rtos bench$secsFast 2 3) "\n"))
  (if fptr
    (princ (strcat "* (Standard) : " (rtos bench$secsNorm 2 3) "  VLE-SUBLIST : " (rtos bench$secsFast 2 3) "\n") fptr)
  )

  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_vle_sublist (* 250 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
