(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(defun t_eq ( count fptr / i time1 time2 lst1 lst2 xxx )

  ;;--- build data list
  (setq i 0)
  (repeat 1000
    (setq lst1 (cons i lst1))
    (setq lst2 (cons i lst2))
    (setq i (1+ i))
  )
  (setq xxx (cons 2 "{"))

  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)

    (eq lst1 lst2)
                                            
    (eq 10.0 10)
    (eq '(10.0) '(10))
    (eq '(10 0.0) '(10 0))
    (eq '(10 0.0 0.0 0.0 ) '(10 0 0 0))
                                            
    (eq '(10.0) '(9.9))
    (eq '(10.0 10) '(9.9 9))
    (eq '(10.0 10 10) '(9.9 9 9.5))
    (eq '(10.0 10 10 10) '(9.9 9 9.5 9))
                                            
    (eq '((10) (10)) '((10) (10)))
    (eq '((10) (10.0)) '((10) (10.0)))
    (eq '((10) (10)) '((10.0) (10.0)))
                                            
    (eq '(2 . 1) '(2 . 1))
    (eq '(2 . 1) '(2 . 2))
    (eq '(2 . 1) '(2 . "A"))
                                            
    (eq '(10.0) '(nil))
                                            
    (eq 1 "a")
                                            
    (eq '(2 . "{") xxx)
    (eq '(2 . "}") xxx)
                                            
    (eq (cons 2 "}") (cons 2 "}"))
    (eq (cons 2 "}") (cons 2 "{"))
    (eq (cons 2 "a") (cons 2 "b"))
    (eq (cons 2 111) (cons 2 222))
    (eq (cons 2 111.0) (cons 2 111.0))
    (eq (cons 1 111.0) (cons 2 111.0))
                                            
    (eq '(2 . 1) '(2 . 1))
    (eq '(2 . 1) '(2 . 2))
    (eq '(2 . 1) '(2 . "A"))
                                            
    (eq '(10.0 10 10) '(9.9 9 9.5))

  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------

  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* EQ : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* EQ : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_eq (* 300 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
