(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(defun t_equal ( count fptr / i time1 time2 lst1 lst2 xxx )

  ;;--- build data list
  (setq i 0)
  (repeat 1000
    (setq lst1 (cons i lst1))
    (setq lst2 (cons i lst2))
    (setq i (1+ i))
  )
  (setq xxx (cons 2 "{"))

  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)

    (equal lst1 lst2)
    
    (equal 10.0 10)
    (equal '(10.0) '(10))
    (equal '(10 0.0) '(10 0))
    (equal '(10 0.0 0.0 0.0 ) '(10 0 0 0))
    
    (equal '(10.0) '(9.9) 2.0)
    (equal '(10.0 10) '(9.9 9) 2.0)
    (equal '(10.0 10 10) '(9.9 9 9.5) 2.0)
    (equal '(10.0 10 10 10) '(9.9 9 9.5 9) 2.0)
    (equal '(10.0 10 10 10 10.0) '(9.9 9 9.5 9 9.8) 2.0)
    
    (equal '((10) (10)) '((10) (10)))
    (equal '((10) (10.0)) '((10) (10.0)))
    (equal '((10) (10)) '((10.0) (10.0)))
    (equal '((10) (10)) '((10.1) (10.1)) 1)
    (equal '((10 10) (10 10)) '((10.1 10.1) (10.1 10.1)) 1)
    
    (equal '(2 . 1) '(2 . 1))
    (equal '(2 . 1) '(2 . 2))
    (equal '(2 . 1) '(2 . "A"))
    
    (equal '(10.0) '(nil))
    
    (equal 1 "a")
    
    (equal '(2 . "{") xxx)
    (equal '(2 . "}") xxx)
    
    (equal (cons 2 "}") (cons 2 "}"))
    (equal (cons 2 "}") (cons 2 "{"))
    (equal (cons 2 "a") (cons 2 "b"))
    (equal (cons 2 111) (cons 2 222))
    (equal (cons 2 111.0) (cons 2 111.0))
    (equal (cons 1 111.0) (cons 2 111.0))
    
    (equal '(2 . 1) '(2 . 1))
    (equal '(2 . 1) '(2 . 2))
    (equal '(2 . 1) '(2 . "A"))
    
    (equal '(10.0 10 10)'(9.9 9 9.5) 1.0)

  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------

  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* EQUAL : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* EQUAL : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_equal (* 150 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
