(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(vl-load-com)

(defun t_gc ( count fptr / i time1 time2 lst ctr )

  ;;----- prepare large data ----
  (setq lst nil ctr 0)
  (repeat 10000
    (setq lst (cons ctr lst))
    (setq ctr (1+ ctr))
  )

  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat count
    (gc)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------

  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* EQUAL : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* EQUAL : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
;(princ "\n* GC number of symbols : ")(princ (length (atoms-family 0)))
;(gc)
  (print)
  (t_gc (* 500 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
