(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(defun t_grdraw ( count fptr / time1 time2 cmdecho )
  
  (setq cmdecho (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (command "_zoom" "_window" '(-10 -10) '(10 10))

  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (grdraw '(0 0) '(1 0) 1)
    (grdraw '(1 0) '(1 1) 1)
    (grdraw '(1 1) '(0 1) 1)
    (grdraw '(0 1) '(0 0) 1)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (redraw)
  (setvar "CMDECHO" cmdecho)
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* GRDRAW : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* GRDRAW : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_grdraw (* 300 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
