(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(defun t_load_lsp_big ( count fptr / i time1 time2 )
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat count
    (load "Benches\\=TestFile-Big=.lsx")
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* LOAD LSP  Big  : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* LOAD LSP  Big  : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

(defun t_load_lsp_small ( count fptr / i time1 time2 )
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat count
    (load "Benches\\=TestFile-Small=.lsx")
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* LOAD LSP Small : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* LOAD LSP Small : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_load_lsp_big   (*   4 $benchcyclesfactor) nil)  
  (t_load_lsp_small (* 150 $benchcyclesfactor) nil)  
  (setvar "cmdecho" 1)
  (princ)
)
