(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(defun t_max ( count fptr / time1 time2 lst i )

  ;;--- build data list
  (setq i 0)
  (setq lst nil)
  (repeat 1000
    (setq lst (cons i lst))
    (setq i (1+ i))
  )

  ;;--- now run test
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (apply 'max lst)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;--- test results
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* MAX : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* MAX : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_max (* 200 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
