(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(if (not $BenchTempFolder) (setq $BenchTempFolder ""))

(setq _$localtestfile (strcat $BenchTempFolder "readwrite-line.log"))

(defun t_writeline ( count fptr / time1 time2 file )
  (setq file (open _$localtestfile "w"))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (write-line "abcdefghi 0123456789" file)
  )
  (write-line "===== EOF =====" file)

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (close file)

  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* WRITE-LINE : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* WRITE-LINE : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

(defun t_readline ( count fptr / time1 time2 file ctr )
  (setq file (open _$localtestfile "r"))
  (if (not file) (exit))
  (setq ctr 0)
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (while (read-line file)
    (setq ctr (1+ ctr))
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (close file)

  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* READ-LINE  : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* READ-LINE  : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_writeline (* 500 $benchcyclesfactor) nil)
  (t_readline  (* 500 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
