(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(defun t_subst ( count fptr / time1 time2 lst i j )

  ;;--- build data list
  (setq i 0)
  (setq lst nil)
  (repeat (1+ count)
    (setq lst (cons (cons i i) lst))
    (setq i (1+ i))
  )
  (setq lst (reverse lst))    ;; ((0 . 0) (1 . 1) (2 . 2) ... (999 . 999))

  (setq j count)
  (setq i (1- j))

  ;;--- now run test
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat count
    (subst (cons j j) (cons i i) lst)
    (setq j i)
    (setq i (1- i))
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;--- test results
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* SUBST : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* SUBST : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_subst (* 1000 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
