(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(defun t_textbox ( count fptr / elist time1 time2 )

  ;;--- build data list
  (setq elist (list (cons 0 "TEXT")(cons 1 "abcdef")(cons 40 1.0)))
  ;;--- now run test
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (textbox elist)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;--- test results
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* TEXTBOX : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* TEXTBOX : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_textbox (* 200 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
