(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(defun t_writechar_screen ( count fptr / time1 time2 )

  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (write-char 48) ; 0
    (write-char 49) ; 1
    (write-char 50) ; 2
    (write-char 51) ; 3
    (write-char 52) ; 4
    (write-char 53) ; 5
    (write-char 54) ; 6
    (write-char 55) ; 7
    (write-char 56) ; 8
    (write-char 57) ; 9
  )
  (write-line "===== DONE =====")

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------

  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* WRITE-CHAR (Screen) : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* WRITE-CHAR (Screen) : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_writechar_screen (* 100 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
