(setq hasMilliSecs (/= (getvar "MILLISECS") nil))
(setvar "LOGFILEMODE" 0)

(defun t_xdroom ( count fptr / time1 time2 elist ename )
  ;;-----------------------------
  (regapp "MYAPP")
  (setq elist '((0 . "POINT") (10 0.0 0.0 0.0)))
  (setq elist (append elist '((-3 ("MYAPP" (1000 . "xxxxxxxx"))))))
  (setq ename (entmakex elist))
  ;;-----------------------------
  (setq time1 (getvar "MILLISECS"))
  (if (not time1) (setq time1 (getvar "TDUSRTIMER")))
  (if (not time1) (setq time1 0.0))

  (repeat (* count count)
    (xdroom ename)
  )

  (setq time2 (getvar "MILLISECS"))
  (if (not time2) (setq time2 (getvar "TDUSRTIMER")))
  (if (not time2) (setq time2 0.0))
  ;;-----------------------------
  (entdel ename)
  ;;-----------------------------
  (setq bench$seconds (if hasMilliSecs (* 0.001 (- time2 time1)) (* 86400.0 (- time2 time1))))
  (princ (strcat "* XDROOM : " (rtos bench$seconds 2 3) "\n"))
  (if fptr
    (princ (strcat "* XDROOM : " (rtos bench$seconds 2 3) "\n") fptr)
  )
  bench$seconds
)

;; to increase/decrease the number of bench loops : > 1 increase < 1 decrease
(if (not $benchcyclesfactor) (setq $benchcyclesfactor 1))

;; to run this loaded test manually
(defun C:Run ()
  (setvar "cmdecho" 0)
  (print)
  (t_xdroom (* 500 $benchcyclesfactor) nil)
  (setvar "cmdecho" 1)
  (princ)
)
